unit AdrMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, Grids, DBGrids, StdCtrls, ExtCtrls, DBCtrls,
  FastSrch;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table1NAME: TStringField;
    Table1CITY: TStringField;
    Table1INFO: TMemoField;
    DBMemo1: TDBMemo;
    DBNavigator1: TDBNavigator;
    Bevel1: TBevel;
    Label1: TLabel;
    EdSearch: TEdit;
    Label2: TLabel;
    ListBox1: TListBox;
    Label3: TLabel;
    ListBox2: TListBox;
    Label4: TLabel;
    Button1: TButton;
    ListBox3: TListBox;
    Label5: TLabel;
    Label6: TLabel;
    FastSearch1: TFastSearch;
    procedure EdSearchChange(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure ListBox3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}



procedure TForm1.EdSearchChange(Sender: TObject);
begin
  // the search word has been changed.. now list all words in the
  // index file that match this word
  FastSearch1.ListPartial (EdSearch.Text, (ListBox3.ItemIndex = 3), ListBox1.Items);
  // clear the list of hits
  ListBox2.Items.Clear;
end;


procedure TForm1.ListBox1Click(Sender: TObject);
var
  Tmp : TStringList;
begin
  // We clicked on a word that exists in the index field.
  // Now list all record numbers that contain this word;
  // search in the selected field or in all fields
  Tmp := TStringList.Create;
  with ListBox1 do
    FastSearch1.Search(Items[ItemIndex], Tmp);
  ListBox2.Items.Assign (Tmp);
  Tmp.Free;
end;

procedure TForm1.ListBox2Click(Sender: TObject);
begin
  // We clicked on one of the hits in the result list -
  // display the record in the table
  with Table1, ListBox2 do
  begin
    First;
    MoveBy (StrToInt(Items[ItemIndex]));
  end;
end;

procedure TForm1.ListBox3Click(Sender: TObject);
begin
  // a new TField has been selected to search in
  with ListBox3 do
  begin
    ListBox1.Enabled := ItemIndex < 3;
    ListBox2.Enabled := ItemIndex < 3;

    if ItemIndex < 3 then
      FastSearch1.SelectField(Table1.FieldByName(Items[ItemIndex]));
  end;
  // Update the other two listboxes
  EdSearchChange(Sender);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ListBox3.ItemIndex := 0; // select the first field
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  FastSearch1.RebuildIndex(true, true);
end;

end.
